/*                                           -*- mode: c; c-basic-offset: 2 -*-
 *
 * This is kiba, a fun GNOME dock
 */

#ifndef __KIBA_GCONF_H__
#define __KIBA_GCONF_H__

#define KIBA_GCONF_PATH "/apps/kiba"

#ifndef __KIBA_DOCK_H__
  typedef struct _KibaGconf  KibaGconf;
#endif

struct _KibaGconf {
  GConfClient     *client;

  /* clock plugin */
  gchar           *clock_face;
  gchar           *clock_color;
  gchar           *clock_border_color;
  gchar           *clock_date_text_color;
  gchar           *clock_marker_color;
  gchar           *clock_hour_hand_color;
  gchar           *clock_minute_hand_color;
  gchar           *clock_second_hand_color;
  gchar           *clock_circle_color;
  gchar           *clock_shadow;
  gchar           *clock_marks;
  gchar           *clock_glass;
  gchar           *clock_hour_hand;
  gchar           *clock_minute_hand;
  gchar           *clock_second_hand;
  gint             clock_position;
  double           clock_alpha;
  double           clock_size;
  double           clock_border_alpha;
  double           clock_border_width;
  double           clock_marker_width;
  double           clock_circle_radius;
  gboolean         clock_enable;
  gboolean         clock_show_seconds;
  gboolean         clock_show_date;
  gboolean         clock_24mode;

  /* memory plugin */
  gchar           *memory_face;
  gchar           *memory_progress_color;
  gchar           *memory_color;
  gchar           *memory_border_color;
  gchar           *memory_progress_bg;
  gint             memory_position;
  double           memory_object_size;
  double           memory_alpha;
  double           memory_progress_alpha;
  double           memory_border_width;
  double           memory_border_alpha;
  gboolean         memory_enable;

  /* launcher plugin */
  GSList          *launcher_multiple_instances;
  gchar           *launcher_running_color;
  double           launcher_alpha;
  double           launcher_running_alpha;
  double           launcher_inactive_alpha;
  gint             icon_size;
  gboolean         launcher_enable;

  /* taskbar plugin */
  GSList          *taskbar_skip_app;
  gchar           *taskbar_border_color;
  gchar           *taskbar_inactive_blend_color;
  gchar           *taskbar_icon_edge;
  gchar           *taskbar_fallback_icon;
  double           taskbar_border_alpha;
  double           taskbar_inactive_blend_alpha;
  double           taskbar_border_radius;
  double           taskbar_border_width;
  double           taskbar_icon_alpha;
  double           taskbar_icon_scale_factor;
  double           taskbar_icon_size;
  gboolean         taskbar_enable;
  gboolean         taskbar_inactive_icon_blend;

  /* gconf entrys */
  gboolean         animated_background;
  gboolean         auto_hide;
  gboolean         exec_rotate;
  gboolean         mouse_cursor_related_rotating;
  gboolean         mouseover_rotating;
  gboolean         pulse_exec;
  gboolean         pulse_while_dragging;
  gboolean         rope_spring_while_dragging;
  gboolean         show_all_borders;
  gboolean         text_enable;
  gboolean         text_while_dragging;
  gchar           *arrow_background;
  gchar           *border_color;
  gchar           *dock_background;
  gchar           *dock_color_1;
  gchar           *dock_color_2;
  gchar           *dock_color_3;
  gchar           *dock_color_4;
  gchar           *dock_color_5;
  gchar           *dock_corner_topleft;
  gchar           *dock_corner_topright;
  gchar           *dock_corner_bottomleft;
  gchar           *dock_corner_bottomright;
  gchar           *object_model;
  gchar           *mouse_over_effect;
  gchar           *prelight_color;
  gchar           *position;
  gchar           *text_color;
  gchar           *text_shadow_color;
  gchar           *text_background;
  gchar           *text_border_style;
  gchar           *text_bg_color_1;
  gchar           *text_bg_color_2;
  gchar           *text_bg_color_3;
  gchar           *text_bg_color_4;
  gchar           *text_bg_color_5;
  gchar           *text_border_color;
  gchar           *text_type;
  gchar           *text_placement_x;
  gchar           *text_placement_y;
  gchar           *text_weight;
  gint             auto_hide_area;
  gint             auto_hide_delay;
  gint             auto_hide_speed;
  gint             cap_margin;
  gint             cap_size;
  gint             dock_position_stepsize;
  gint             exec_rotate_velocity;
  gint             object_wobbly_spring;
  gint             monitor_number;
  gint             mouseover_rotate_velocity;
  gint             rope_gravity;
  gint             text_shadow_offset;
  gint             text_position_stepsize;
  gint             text_size;
  gint             text_icon_padding;
  gint             text_hide_delay;
  double           bounce_height;
  double           border_alpha;
  double           border_width;
  double           dock_alpha_1;
  double           dock_alpha_2;
  double           dock_alpha_3;
  double           dock_alpha_4;
  double           dock_alpha_5;
  double           dock_bg_affection;
  double           dock_bg_step_size;
  double           arrow_bg_step_size;
  double           text_bg_step_size;
  double           arrow_bg_affection;
  double           text_bg_affection;
  double           dock_bg_radius_1;
  double           dock_bg_radius_2;
  double           text_bg_radius_1;
  double           text_bg_radius_2;
  double           arrow_bg_radius_1;
  double           arrow_bg_radius_2;
  double           gravity_multiplier;
  double           inertia;
  double           margin;
  double           mouseover_bouncing_height;
  double           mouse_translation;
  double           object_space;
  double           prelight_alpha;
  double           pulse_exec_stepsize;
  double           pulse_exec_zoom_factor;
  double           pulse_stepsize;
  double           pulse_max_alpha;
  double           pulse_zoom_factor;
  double           radius;
  double           rope_object_distance;
  double           rotate_area_factor;
  double           rotate_scale_factor;
  double           text_alpha;
  double           text_shadow_alpha;
  double           text_bg_alpha_1;
  double           text_bg_alpha_2;
  double           text_bg_alpha_3;
  double           text_bg_alpha_4;
  double           text_bg_alpha_5;
  double           text_border_alpha;
  double           text_border_width;
  double           throw_gravity;
  double           zoom_factor;
  double           zoom_max_stepsize;
  double           zoom_area_factor;
};

#ifndef NO_GCONF_FUNCTS
void
kiba_gconf_init_defaults       (AkamaruModel *model, KibaGconf *gconf);
void
kiba_gconf_get_settings        (KibaDock *dock);
void
set_option                     (KibaDock *dock, GConfEntry *entry);
void
kiba_switch_model              (GtkWidget *widget, gpointer data);
void
toggle_auto_hide               (GtkWidget *widget, gpointer data);
void
options_changed_callback       (GConfClient *client, guint cnxn_id, GConfEntry *entry, gpointer  user_data);
#endif

#define define_struct_member(a,b)   struct { const char *name; size_t offset; } options[] = {\
    { "elasticity", G_STRUCT_OFFSET (b, elasticity) },\
    { "friction", G_STRUCT_OFFSET (b, friction) },\
    { "k", G_STRUCT_OFFSET (b, k) },\
    { "animated_background", G_STRUCT_OFFSET (a, animated_background) },\
    { "text_position_stepsize", G_STRUCT_OFFSET (a, text_position_stepsize) },\
    { "dock_position_stepsize", G_STRUCT_OFFSET (a, dock_position_stepsize) },\
    { "position", G_STRUCT_OFFSET (a, position) },\
    { "arrow_background", G_STRUCT_OFFSET (a, arrow_background) },\
    { "auto_hide", G_STRUCT_OFFSET (a, auto_hide) },\
    { "auto_hide_delay", G_STRUCT_OFFSET (a, auto_hide_delay) },\
    { "auto_hide_speed", G_STRUCT_OFFSET (a, auto_hide_speed) },\
    { "auto_hide_area", G_STRUCT_OFFSET (a, auto_hide_area) },\
    { "border_alpha", G_STRUCT_OFFSET (a, border_alpha) },\
    { "border_color", G_STRUCT_OFFSET (a, border_color) },\
    { "text_border_style", G_STRUCT_OFFSET (a, text_border_style) },\
    { "border_width", G_STRUCT_OFFSET (a, border_width) },\
    { "bounce_height", G_STRUCT_OFFSET (a, bounce_height) },\
    { "exec_rotate_velocity", G_STRUCT_OFFSET (a, exec_rotate_velocity) },\
    { "cap_size", G_STRUCT_OFFSET (a, cap_size) },\
    { "cap_margin", G_STRUCT_OFFSET (a, cap_margin) },\
    { "dock_alpha_1", G_STRUCT_OFFSET (a, dock_alpha_1) },\
    { "dock_alpha_2", G_STRUCT_OFFSET (a, dock_alpha_2) },\
    { "dock_alpha_3", G_STRUCT_OFFSET (a, dock_alpha_3) },\
    { "dock_alpha_4", G_STRUCT_OFFSET (a, dock_alpha_4) },\
    { "dock_alpha_5", G_STRUCT_OFFSET (a, dock_alpha_5) },\
    { "exec_rotate", G_STRUCT_OFFSET (a, exec_rotate) },\
    { "dock_bg_step_size", G_STRUCT_OFFSET (a, dock_bg_step_size) },\
    { "text_bg_step_size", G_STRUCT_OFFSET (a, text_bg_step_size) },\
    { "arrow_bg_step_size", G_STRUCT_OFFSET (a, arrow_bg_step_size) },\
    { "mouse_translation", G_STRUCT_OFFSET (a, mouse_translation) },\
    { "dock_background", G_STRUCT_OFFSET (a, dock_background) },\
    { "dock_bg_affection", G_STRUCT_OFFSET (a, dock_bg_affection) },\
    { "arrow_bg_affection", G_STRUCT_OFFSET (a, arrow_bg_affection) },\
    { "text_bg_affection", G_STRUCT_OFFSET (a, text_bg_affection) },\
    { "dock_bg_radius_1", G_STRUCT_OFFSET (a, dock_bg_radius_1) },\
    { "dock_bg_radius_2", G_STRUCT_OFFSET (a, dock_bg_radius_2) },\
    { "text_bg_radius_1", G_STRUCT_OFFSET (a, text_bg_radius_1) },\
    { "arrow_bg_radius_2", G_STRUCT_OFFSET (a, arrow_bg_radius_2) },\
    { "arrow_bg_radius_1", G_STRUCT_OFFSET (a, arrow_bg_radius_1) },\
    { "text_bg_radius_2", G_STRUCT_OFFSET (a, text_bg_radius_2) },\
    { "dock_color_1", G_STRUCT_OFFSET (a, dock_color_1) },\
    { "dock_color_2", G_STRUCT_OFFSET (a, dock_color_2) },\
    { "dock_color_3", G_STRUCT_OFFSET (a, dock_color_3) },\
    { "dock_color_4", G_STRUCT_OFFSET (a, dock_color_4) },\
    { "dock_color_5", G_STRUCT_OFFSET (a, dock_color_5) },\
    { "dock_corner_topleft", G_STRUCT_OFFSET (a, dock_corner_topleft) },\
    { "dock_corner_topright", G_STRUCT_OFFSET (a, dock_corner_topright) },\
    { "dock_corner_bottomleft", G_STRUCT_OFFSET (a, dock_corner_bottomleft) },\
    { "dock_corner_bottomright", G_STRUCT_OFFSET (a, dock_corner_bottomright) },\
    { "gravity_multiplier", G_STRUCT_OFFSET (a, gravity_multiplier) },\
    { "icon_size", G_STRUCT_OFFSET (a, icon_size) },\
    { "inertia", G_STRUCT_OFFSET (a, inertia) },\
    { "margin", G_STRUCT_OFFSET (a, margin) },\
    { "mouse_cursor_related_rotating", G_STRUCT_OFFSET (a, mouse_cursor_related_rotating) },\
    { "mouse_over_effect", G_STRUCT_OFFSET (a, mouse_over_effect) },\
    { "mouseover_rotating", G_STRUCT_OFFSET (a, mouseover_rotating) },\
    { "mouseover_rotate_velocity", G_STRUCT_OFFSET (a, mouseover_rotate_velocity) },\
    { "pulse_exec", G_STRUCT_OFFSET (a, pulse_exec) },\
    { "pulse_while_dragging", G_STRUCT_OFFSET (a, pulse_while_dragging) },\
    { "pulse_max_alpha", G_STRUCT_OFFSET (a, pulse_max_alpha) },\
    { "object_wobbly_spring", G_STRUCT_OFFSET (a, object_wobbly_spring) },\
    { "launcher_alpha", G_STRUCT_OFFSET (a, launcher_alpha) },\
    { "launcher_enable", G_STRUCT_OFFSET (a, launcher_enable) },\
    { "launcher_multiple_instances", G_STRUCT_OFFSET (a, launcher_multiple_instances) },\
    { "launcher_running_color", G_STRUCT_OFFSET (a, launcher_running_color) },\
    { "launcher_running_alpha", G_STRUCT_OFFSET (a, launcher_running_alpha) },\
    { "launcher_inactive_alpha", G_STRUCT_OFFSET (a, launcher_inactive_alpha) },\
    { "model", G_STRUCT_OFFSET (a, object_model) },\
    { "monitor_number", G_STRUCT_OFFSET (a, monitor_number) },\
    { "mouseover_bouncing_height", G_STRUCT_OFFSET (a, mouseover_bouncing_height) },\
    { "object_space", G_STRUCT_OFFSET (a, object_space) },\
    { "prelight_alpha", G_STRUCT_OFFSET (a, prelight_alpha) },\
    { "prelight_color", G_STRUCT_OFFSET (a, prelight_color) },\
    { "pulse_stepsize", G_STRUCT_OFFSET (a, pulse_stepsize) },\
    { "pulse_exec_stepsize", G_STRUCT_OFFSET (a, pulse_exec_stepsize) },\
    { "pulse_exec_zoom_factor", G_STRUCT_OFFSET (a, pulse_exec_zoom_factor) },\
    { "radius", G_STRUCT_OFFSET (a, radius) },\
    { "rope_object_distance", G_STRUCT_OFFSET (a, rope_object_distance) },\
    { "rope_gravity", G_STRUCT_OFFSET (a, rope_gravity) },\
    { "rope_spring_while_dragging", G_STRUCT_OFFSET (a, rope_spring_while_dragging) },\
    { "memory_object_size", G_STRUCT_OFFSET (a, memory_object_size) },\
    { "memory_face", G_STRUCT_OFFSET (a, memory_face) },\
    { "memory_position", G_STRUCT_OFFSET (a, memory_position) },\
    { "memory_alpha", G_STRUCT_OFFSET (a, memory_alpha) },\
    { "memory_enable", G_STRUCT_OFFSET (a, memory_enable) },\
    { "memory_progress_bg", G_STRUCT_OFFSET (a, memory_progress_bg) },\
    { "memory_progress_color", G_STRUCT_OFFSET (a, memory_progress_color) },\
    { "memory_progress_alpha", G_STRUCT_OFFSET (a, memory_progress_alpha) },\
    { "memory_border_width", G_STRUCT_OFFSET (a, memory_border_width) },\
    { "memory_color", G_STRUCT_OFFSET (a, memory_color) },\
    { "memory_border_color", G_STRUCT_OFFSET (a, memory_border_color) },\
    { "memory_border_alpha", G_STRUCT_OFFSET (a, memory_border_alpha) },\
    { "taskbar_icon_alpha", G_STRUCT_OFFSET (a, taskbar_icon_alpha) },\
    { "taskbar_icon_size", G_STRUCT_OFFSET (a, taskbar_icon_size) },\
    { "taskbar_enable", G_STRUCT_OFFSET (a, taskbar_enable) },\
    { "taskbar_border_width", G_STRUCT_OFFSET (a, taskbar_border_width) },\
    { "taskbar_border_radius", G_STRUCT_OFFSET (a, taskbar_border_radius) },\
    { "taskbar_border_alpha", G_STRUCT_OFFSET (a, taskbar_border_alpha) },\
    { "taskbar_border_color", G_STRUCT_OFFSET (a, taskbar_border_color) },\
    { "taskbar_skip_app", G_STRUCT_OFFSET (a, taskbar_skip_app) },\
    { "taskbar_icon_edge", G_STRUCT_OFFSET (a, taskbar_icon_edge) },\
    { "taskbar_icon_scale_factor", G_STRUCT_OFFSET (a, taskbar_icon_scale_factor) },\
    { "taskbar_inactive_blend_color", G_STRUCT_OFFSET (a, taskbar_inactive_blend_color) },\
    { "taskbar_inactive_blend_alpha", G_STRUCT_OFFSET (a, taskbar_inactive_blend_alpha) },\
    { "taskbar_inactive_icon_blend", G_STRUCT_OFFSET (a, taskbar_inactive_icon_blend) },\
    { "taskbar_fallback_icon", G_STRUCT_OFFSET (a, taskbar_fallback_icon) },\
    { "clock_size", G_STRUCT_OFFSET (a, clock_size) },\
    { "clock_alpha", G_STRUCT_OFFSET (a, clock_alpha) },\
    { "clock_face", G_STRUCT_OFFSET (a, clock_face) },\
    { "clock_border_alpha", G_STRUCT_OFFSET (a, clock_border_alpha) },\
    { "clock_border_color", G_STRUCT_OFFSET (a, clock_border_color) },\
    { "clock_border_width", G_STRUCT_OFFSET (a, clock_border_width) },\
    { "clock_color", G_STRUCT_OFFSET (a, clock_color) },\
    { "clock_date_text_color", G_STRUCT_OFFSET (a, clock_date_text_color) },\
    { "clock_enable", G_STRUCT_OFFSET (a, clock_enable) },\
    { "clock_show_seconds", G_STRUCT_OFFSET (a, clock_show_seconds) },\
    { "clock_show_date", G_STRUCT_OFFSET (a, clock_show_date) },\
    { "clock_marker_color", G_STRUCT_OFFSET (a, clock_marker_color) },\
    { "clock_marker_width", G_STRUCT_OFFSET (a, clock_marker_width) },\
    { "clock_circle_radius", G_STRUCT_OFFSET (a, clock_circle_radius) },\
    { "clock_hour_hand_color", G_STRUCT_OFFSET (a, clock_hour_hand_color) },\
    { "clock_minute_hand_color", G_STRUCT_OFFSET (a, clock_minute_hand_color) },\
    { "clock_second_hand_color", G_STRUCT_OFFSET (a, clock_second_hand_color) },\
    { "clock_circle_color", G_STRUCT_OFFSET (a, clock_circle_color) },\
    { "clock_shadow", G_STRUCT_OFFSET (a, clock_shadow) },\
    { "clock_marks", G_STRUCT_OFFSET (a, clock_marks) },\
    { "clock_glass", G_STRUCT_OFFSET (a, clock_glass) },\
    { "clock_hour_hand", G_STRUCT_OFFSET (a, clock_hour_hand) },\
    { "clock_minute_hand", G_STRUCT_OFFSET (a, clock_minute_hand) },\
    { "clock_second_hand", G_STRUCT_OFFSET (a, clock_second_hand) },\
    { "clock_position", G_STRUCT_OFFSET (a, clock_position) },\
    { "clock_24mode", G_STRUCT_OFFSET (a, clock_24mode) },\
    { "rotate_area_factor", G_STRUCT_OFFSET (a, rotate_area_factor) },\
    { "rotate_scale_factor", G_STRUCT_OFFSET (a, rotate_scale_factor) },\
    { "zoom_factor", G_STRUCT_OFFSET (a, zoom_factor) },\
    { "pulse_zoom_factor", G_STRUCT_OFFSET (a, pulse_zoom_factor) },\
    { "zoom_max_stepsize", G_STRUCT_OFFSET (a, zoom_max_stepsize) },\
    { "zoom_area_factor", G_STRUCT_OFFSET (a, zoom_area_factor) },\
    { "show_all_borders", G_STRUCT_OFFSET (a, show_all_borders) },\
    { "text_color", G_STRUCT_OFFSET (a, text_color) },\
    { "text_alpha", G_STRUCT_OFFSET (a, text_alpha) },\
    { "text_shadow_color", G_STRUCT_OFFSET (a, text_shadow_color) },\
    { "text_shadow_alpha", G_STRUCT_OFFSET (a, text_shadow_alpha) },\
    { "text_background", G_STRUCT_OFFSET (a, text_background) },\
    { "text_shadow_offset", G_STRUCT_OFFSET (a, text_shadow_offset) },\
    { "text_bg_color_1", G_STRUCT_OFFSET (a, text_bg_color_1) },\
    { "text_bg_color_2", G_STRUCT_OFFSET (a, text_bg_color_2) },\
    { "text_bg_color_3", G_STRUCT_OFFSET (a, text_bg_color_3) },\
    { "text_bg_color_4", G_STRUCT_OFFSET (a, text_bg_color_4) },\
    { "text_bg_color_5", G_STRUCT_OFFSET (a, text_bg_color_5) },\
    { "text_bg_alpha_1", G_STRUCT_OFFSET (a, text_bg_alpha_1) },\
    { "text_bg_alpha_2", G_STRUCT_OFFSET (a, text_bg_alpha_2) },\
    { "text_bg_alpha_3", G_STRUCT_OFFSET (a, text_bg_alpha_3) },\
    { "text_bg_alpha_4", G_STRUCT_OFFSET (a, text_bg_alpha_4) },\
    { "text_bg_alpha_5", G_STRUCT_OFFSET (a, text_bg_alpha_5) },\
    { "text_border_color", G_STRUCT_OFFSET (a, text_border_color) },\
    { "text_border_alpha", G_STRUCT_OFFSET (a, text_border_alpha) },\
    { "text_border_width", G_STRUCT_OFFSET (a, text_border_width) },\
    { "text_hide_delay", G_STRUCT_OFFSET (a, text_hide_delay) },\
    { "text_size", G_STRUCT_OFFSET (a, text_size) },\
    { "text_type", G_STRUCT_OFFSET (a, text_type) },\
    { "text_icon_padding", G_STRUCT_OFFSET (a, text_icon_padding) },\
    { "text_enable", G_STRUCT_OFFSET (a, text_enable) },\
    { "text_placement_x", G_STRUCT_OFFSET (a, text_placement_x) },\
    { "text_placement_y", G_STRUCT_OFFSET (a, text_placement_y) },\
    { "text_weight", G_STRUCT_OFFSET (a, text_weight) },\
    { "text_while_dragging", G_STRUCT_OFFSET (a, text_while_dragging) },\
    { "throw_gravity", G_STRUCT_OFFSET (a, throw_gravity) }\
  }

#endif
